using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Armor
{
    public class Mod
    {
        public static void Main()
        {
             CategoryBuilder.Create("Breaking Bad Mod", "Breaking Bad Mod", ModAPI.LoadSprite("BreakingBadThumb.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Walter White",
                    DescriptionOverride = "I Am The One Who Knocks.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("WalterWhiteThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("WalterWhite.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Todd Alquist",
                    DescriptionOverride = "Left over ice cream.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("ToddAlquistThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("ToddAlquist.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Gus Fring",
                    DescriptionOverride = "Owner of Los Pollos Hermanos",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("GusFringThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("GusFring.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Heisenberg",
                    DescriptionOverride = "Say my name.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("HeisenbergThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Heisenberg.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );   
            
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mike Ehrmantraut",
                    DescriptionOverride = "A former Philadelphia police officer.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("MikeEhrmantrautThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("MikeEhrmantraut.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            ); 

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hank Schrader",
                    DescriptionOverride = "Go fuck youself.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("HankSchraderThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HankSchrader.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            ); 

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Saul Goodman",
                    DescriptionOverride = "A former scam artist.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("SaulGoodmanThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("SaulGoodman.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );  

             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jesse Pinkman",
                    DescriptionOverride = "Bitch",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("JessePinkmanThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("JessePinkman.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                    }
                }
            );   

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Walt's Aztec",
                    NameToOrderByOverride = "Walt's Aztec",
                    DescriptionOverride = "Probably the most recognisable vehicle around.",
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("Walt'sAztecThumb2.PNG", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Walt'sAztec.png", 1f),
                                };
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 20f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Walt'sAztec.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Bag Of Meth", 
                    DescriptionOverride = "Baby Blue.", 
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("BagOfMethThumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BagOfMeth.png");
			 Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Pizza", 
                    DescriptionOverride = "Just some ordinary pizza.", 
                    CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("PizzaThumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pizza.png");
			 Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                }
            );

		    ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Plank"), //item to derive from
                   NameOverride = "Heisenberg Hat", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "hey look at this neat hat", //new item description
                   CategoryOverride = ModAPI.FindCategory("Breaking Bad Mod"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("HeisenbergHatThumb.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HeisenbergHat.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
					    Instance.FixColliders();
						ArmorBehaviour armor = Instance.GetOrAddComponent<ArmorBehaviour>();

						ArmorProperties prop = new ArmorProperties();
												
						prop.armorPiece = "Head";
						prop.armorTier = 0;
						prop.sprite = "HeisenbergHat.png";

						armor.prop = prop;
						armor.SetProperties();
					}	
			    }
		    ); 
        }
    }
}
            